Attribute VB_Name = "Module1"
Option Explicit

Private Type STARTUPINFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

Private Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessID As Long
    dwThreadID As Long
End Type

Private Declare Function SetPriorityClass Lib "kernel32" (ByVal _
        hProcess As Long, ByVal dwPriorityClass As Long) As Long

Public Const IDLE_PRIORITY_CLASS = &H40
Public Const NORMAL_PRIORITY_CLASS = &H20
Public Const HIGH_PRIORITY_CLASS = &H80
Public Const REALTIME_PRIORITY_CLASS = &H100

Private Declare Function CreateProcessA Lib "kernel32" _
                    (ByVal lpApplicationName As Long, _
                     ByVal lpCommandLine As String, _
                     ByVal lpProcessAttributes As Long, _
                     ByVal lpThreadAttributes As Long, _
                     ByVal bInheritHandles As Long, _
                     ByVal dwCreationFlags As Long, _
                     ByVal lpEnvironment As Long, _
                     ByVal lpCurrentDirectory As Long, _
                     lpStartupInfo As STARTUPINFO, _
                     lpProcessInformation As PROCESS_INFORMATION) As Long

Private Declare Function WaitForSingleObject Lib "kernel32" _
                    (ByVal hHandle As Long, _
                     ByVal dwMilliseconds As Long) As Long

Private Declare Function GetShortPathName Lib "kernel32" _
 Alias "GetShortPathNameA" (ByVal LongPath As String, _
 ByVal ShortPath As String, ByVal BufferSize As Long) As Long

Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Public Function ShortPath(Path As String) As String
  Dim nSize As Long
  On Error Resume Next
  Path = stringreplace(Path, """", "")
  ShortPath = Space$(256)
  nSize = GetShortPathName(Path, ShortPath, 255)
  ShortPath = Left$(ShortPath, nSize)
End Function

Public Function ShellAsynchron(ByVal CmdLine As String, Optional ByVal priority As Long = NORMAL_PRIORITY_CLASS) As Boolean

    Const INFINITE = -1&
    
    Dim proc As PROCESS_INFORMATION
    Dim start As STARTUPINFO
    Dim ret As Long

    start.cb = Len(start)
    ret = CreateProcessA(0&, CmdLine$, 0&, 0&, 1&, _
                         priority, 0&, 0&, start, proc)
    If ret = 0 Then
        ShellAsynchron = False
    Else
        ret = CloseHandle(proc.hProcess)
        ShellAsynchron = True
    End If
End Function

Public Function FileExists(Path As String) As Boolean
  Const NotFile = vbDirectory + vbVolume
  On Error Resume Next
  FileExists = (GetAttr(Path) And NotFile) = 0
End Function

Function stringreplace(eingabe As String, ersetzenvon As String, ersetzendurch As String) As String
    Dim i As Long
    Dim temp As String
    stringreplace = eingabe
    If ersetzenvon = ersetzendurch Then Exit Function
    If ersetzenvon = "" Then Exit Function
    i = 1
    Do Until InStr(i, stringreplace, ersetzenvon) < 1
        temp = Mid$(stringreplace, 1, InStr(i, stringreplace, ersetzenvon) - 1) & ersetzendurch
        stringreplace = temp & Mid$(stringreplace, InStr(i, stringreplace, ersetzenvon) + Len(ersetzenvon))
        i = Len(temp) + 1
    Loop
End Function

